diff --git a/sysdeps/loongarch/fpu/e_scalb.c b/sysdeps/loongarch/fpu/e_scalb.c
new file mode 100644
index 0000000000..de01441186
--- /dev/null
+++ b/sysdeps/loongarch/fpu/e_scalb.c
@@ -0,0 +1,61 @@
+/* scalb().  LoongArch version.
+   Copyright (C) 2022 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#define NO_MATH_REDIRECT
+#include <math.h>
+#include <libm-alias-finite.h>
+#include <fpu_control.h>
+#include <float.h>
+
+double
+__ieee754_scalb (double x, double fn)
+{
+  int x_cond;
+  int fn_cond;
+  asm volatile ("fclass.d \t%0, %1" : "=f" (x_cond) : "f" (x));
+  asm volatile ("fclass.d \t%0, %1" : "=f" (fn_cond) : "f" (fn));
+
+  if (__glibc_unlikely(( x_cond | fn_cond) & _FCLASS_NAN))
+      return x * fn;
+  else if (__glibc_unlikely(fn_cond & _FCLASS_INF))
+    {
+      if (!(fn_cond & _FCLASS_MINF))
+	  return x * fn;
+      else
+	  return x / -fn;
+    }
+  else if (__glibc_likely(-DBL_MAX < fn && fn < DBL_MAX))
+    {
+      long y1;
+      double  y;
+
+      asm volatile ("frint.d \t%0, %1" : "=f" (y) : "f" (fn));
+      asm volatile ("ftintrz.l.d \t%0, %1" : "=f" (y) : "f" (y));
+      asm volatile ("movfr2gr.d \t%0, %1" : "=r" (y1) : "f" (y));
+
+      if (y1 != fn )
+	  return (x - x) / (x - x);
+
+      asm volatile ("fscaleb.d \t%0, %1, %2" : "=f" (x) : "f" (x), "f" (y));
+    }
+  else
+    asm volatile ("fscaleb.d \t%0, %1, %2" : "=f" (x) : "f" (x), "f" (fn));
+
+  return x;
+}
+libm_alias_finite (__ieee754_scalb, __scalb)
diff --git a/sysdeps/loongarch/fpu/e_scalbf.c b/sysdeps/loongarch/fpu/e_scalbf.c
new file mode 100644
index 0000000000..6b617e8fc1
--- /dev/null
+++ b/sysdeps/loongarch/fpu/e_scalbf.c
@@ -0,0 +1,61 @@
+/* scalbf().  LoongArch version.
+   Copyright (C) 2022 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#define NO_MATH_REDIRECT
+#include <math.h>
+#include <libm-alias-finite.h>
+#include <fpu_control.h>
+#include <float.h>
+
+float
+__ieee754_scalbf (float x, float fn)
+{
+  int x_cond;
+  int fn_cond;
+  asm volatile ("fclass.s \t%0, %1" : "=f" (x_cond) : "f" (x));
+  asm volatile ("fclass.s \t%0, %1" : "=f" (fn_cond) : "f" (fn));
+
+  if (__glibc_unlikely(( x_cond | fn_cond) & _FCLASS_NAN))
+      return x * fn;
+  else if (__glibc_unlikely(fn_cond & _FCLASS_INF))
+    {
+      if (!(fn_cond & _FCLASS_MINF))
+	  return x * fn;
+      else
+	  return x / -fn;
+    }
+  else if (__glibc_likely(-FLT_MAX < fn && fn < FLT_MAX))
+    {
+      int y1;
+      float  y;
+
+      asm volatile ("frint.s \t%0, %1" : "=f" (y) : "f" (fn));
+      asm volatile ("ftintrz.w.s \t%0, %1" : "=f" (y) : "f" (y));
+      asm volatile ("movfr2gr.s \t%0, %1" : "=r" (y1) : "f" (y));
+
+      if (y1 != fn )
+	  return (x - x) / (x - x);
+
+      asm volatile ("fscaleb.s \t%0, %1, %2" : "=f" (x) : "f" (x), "f" (y));
+    }
+  else
+    asm volatile ("fscaleb.s \t%0, %1, %2" : "=f" (x) : "f" (x), "f" (fn));
+
+  return x;
+}
+libm_alias_finite (__ieee754_scalb, __scalb)
diff --git a/sysdeps/loongarch/fpu/s_scalbn.c b/sysdeps/loongarch/fpu/s_scalbn.c
new file mode 100644
index 0000000000..c03e81a31e
--- /dev/null
+++ b/sysdeps/loongarch/fpu/s_scalbn.c
@@ -0,0 +1,29 @@
+/* scalbn().  LoongArch version.
+   Copyright (C) 2022 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#define NO_MATH_REDIRECT
+#include <math.h>
+
+double
+__scalbn (double x, int fn)
+{
+  double tmp;
+  asm volatile ("movgr2fr.d \t%0, %1" : "=f" (tmp) : "r" (fn));
+  asm volatile ("fscaleb.d \t%0, %1, %2" : "=f" (x) : "f" (x), "f" (tmp));
+  return x;
+}
diff --git a/sysdeps/loongarch/fpu/s_scalbnf.c b/sysdeps/loongarch/fpu/s_scalbnf.c
new file mode 100644
index 0000000000..15e6428044
--- /dev/null
+++ b/sysdeps/loongarch/fpu/s_scalbnf.c
@@ -0,0 +1,29 @@
+/* scalbnf().  LoongArch version.
+   Copyright (C) 2022 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#define NO_MATH_REDIRECT
+#include <math.h>
+
+float
+__scalbnf (float x, int fn)
+{
+  float tmp;
+  asm volatile ("movgr2fr.w \t%0, %1" : "=f" (tmp) : "r" (fn));
+  asm volatile ("fscaleb.s \t%0, %1, %2" : "=f" (x) : "f" (x), "f" (tmp));
+  return x;
+}