diff --git a/sysdeps/loongarch/fpu/s_fmaximum.c b/sysdeps/loongarch/fpu/s_fmaximum.c
new file mode 100644
index 0000000000..af1c2bf006
--- /dev/null
+++ b/sysdeps/loongarch/fpu/s_fmaximum.c
@@ -0,0 +1,40 @@
+/* fmaximum().  LoongArch version.
+   Copyright (C) 2022 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#define NO_MATH_REDIRECT
+#include <math.h>
+#include <libm-alias-double.h>
+#include <fpu_control.h>
+
+double
+__fmaximum (double x, double y)
+{
+  int x_cond;
+  int y_cond;
+  asm volatile ("fclass.d \t%0, %1" : "=f" (x_cond) : "f" (x));
+  asm volatile ("fclass.d \t%0, %1" : "=f" (y_cond) : "f" (y));
+
+  if (__glibc_unlikely((x_cond | y_cond) & _FCLASS_NAN))
+      return x * y;
+  else
+    {
+      asm volatile ("fmax.d \t%0, %1, %2" : "=f" (x) : "f" (x), "f" (y));
+      return x;
+    }
+}
+libm_alias_double (__fmaximum, fmaximum)
diff --git a/sysdeps/loongarch/fpu/s_fmaximumf.c b/sysdeps/loongarch/fpu/s_fmaximumf.c
new file mode 100644
index 0000000000..da4dcb6a3b
--- /dev/null
+++ b/sysdeps/loongarch/fpu/s_fmaximumf.c
@@ -0,0 +1,40 @@
+/* fmaximumf().  LoongArch version.
+   Copyright (C) 2022 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#define NO_MATH_REDIRECT
+#include <math.h>
+#include <libm-alias-float.h>
+#include <fpu_control.h>
+
+float
+__fmaximumf (float x, float y)
+{
+  int x_cond;
+  int y_cond;
+  asm volatile ("fclass.s \t%0, %1" : "=f" (x_cond) : "f" (x));
+  asm volatile ("fclass.s \t%0, %1" : "=f" (y_cond) : "f" (y));
+
+  if (__glibc_unlikely((x_cond | y_cond) & _FCLASS_NAN))
+      return x * y;
+  else
+    {
+      asm volatile ("fmax.s \t%0, %1, %2" : "=f" (x) : "f" (x), "f" (y));
+      return x;
+    }
+}
+libm_alias_float (__fmaximum, fmaximum)
diff --git a/sysdeps/loongarch/fpu/s_fminimum.c b/sysdeps/loongarch/fpu/s_fminimum.c
new file mode 100644
index 0000000000..e395ff7e62
--- /dev/null
+++ b/sysdeps/loongarch/fpu/s_fminimum.c
@@ -0,0 +1,40 @@
+/* fminimum().  LoongArch version.
+   Copyright (C) 2022 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#define NO_MATH_REDIRECT
+#include <math.h>
+#include <libm-alias-double.h>
+#include <fpu_control.h>
+
+double
+__fminimum (double x, double y)
+{
+  int x_cond;
+  int y_cond;
+  asm volatile ("fclass.d \t%0, %1" : "=f" (x_cond) : "f" (x));
+  asm volatile ("fclass.d \t%0, %1" : "=f" (y_cond) : "f" (y));
+
+  if (__glibc_unlikely((x_cond | y_cond) & _FCLASS_NAN))
+      return x * y;
+  else
+    {
+      asm volatile ("fmin.d \t%0, %1, %2" : "=f" (x) : "f" (x), "f" (y));
+      return x;
+    }
+}
+libm_alias_double (__fminimum, fminimum)
diff --git a/sysdeps/loongarch/fpu/s_fminimumf.c b/sysdeps/loongarch/fpu/s_fminimumf.c
new file mode 100644
index 0000000000..680c5e7e9a
--- /dev/null
+++ b/sysdeps/loongarch/fpu/s_fminimumf.c
@@ -0,0 +1,40 @@
+/* fminimumf().  LoongArch version.
+   Copyright (C) 2022 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#define NO_MATH_REDIRECT
+#include <math.h>
+#include <libm-alias-float.h>
+#include <fpu_control.h>
+
+float
+__fminimumf (float x, float y)
+{
+  int x_cond;
+  int y_cond;
+  asm volatile ("fclass.s \t%0, %1" : "=f" (x_cond) : "f" (x));
+  asm volatile ("fclass.s \t%0, %1" : "=f" (y_cond) : "f" (y));
+
+  if (__glibc_unlikely((x_cond | y_cond) & _FCLASS_NAN))
+      return x * y;
+  else
+    {
+      asm volatile ("fmin.s \t%0, %1, %2" : "=f" (x) : "f" (x), "f" (y));
+      return x;
+    }
+}
+libm_alias_float (__fminimum, fminimum)