diff --git a/sysdeps/loongarch/fpu/s_fmaximum_mag.c b/sysdeps/loongarch/fpu/s_fmaximum_mag.c
new file mode 100644
index 0000000000..5aed0603e6
--- /dev/null
+++ b/sysdeps/loongarch/fpu/s_fmaximum_mag.c
@@ -0,0 +1,40 @@
+/* fmaximum_mag().  LoongArch version.
+   Copyright (C) 2022 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#define NO_MATH_REDIRECT
+#include <math.h>
+#include <libm-alias-double.h>
+#include <fpu_control.h>
+
+double
+__fmaximum_mag (double x, double y)
+{
+  int x_cond;
+  int y_cond;
+  asm volatile ("fclass.d \t%0, %1" : "=f" (x_cond) : "f" (x));
+  asm volatile ("fclass.d \t%0, %1" : "=f" (y_cond) : "f" (y));
+
+  if (__glibc_unlikely((x_cond | y_cond) & _FCLASS_NAN))
+      return x * y;
+  else
+    {
+      asm volatile ("fmaxa.d \t%0, %1, %2" : "=f" (x) : "f" (x), "f" (y));
+      return x;
+    }
+}
+libm_alias_double (__fmaximum_mag, fmaximum_mag)
diff --git a/sysdeps/loongarch/fpu/s_fmaximum_magf.c b/sysdeps/loongarch/fpu/s_fmaximum_magf.c
new file mode 100644
index 0000000000..29beb88c22
--- /dev/null
+++ b/sysdeps/loongarch/fpu/s_fmaximum_magf.c
@@ -0,0 +1,40 @@
+/* fmaximum_magf().  LoongArch version.
+   Copyright (C) 2022 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#define NO_MATH_REDIRECT
+#include <math.h>
+#include <libm-alias-float.h>
+#include <fpu_control.h>
+
+float
+__fmaximum_magf (float x, float y)
+{
+  int x_cond;
+  int y_cond;
+  asm volatile ("fclass.s \t%0, %1" : "=f" (x_cond) : "f" (x));
+  asm volatile ("fclass.s \t%0, %1" : "=f" (y_cond) : "f" (y));
+
+  if (__glibc_unlikely((x_cond | y_cond) & _FCLASS_NAN))
+      return x * y;
+  else
+    {
+      asm volatile ("fmaxa.s \t%0, %1, %2" : "=f" (x) : "f" (x), "f" (y));
+      return x;
+    }
+}
+libm_alias_float (__fmaximum_mag, fmaximum_mag)
diff --git a/sysdeps/loongarch/fpu/s_fminimum_mag.c b/sysdeps/loongarch/fpu/s_fminimum_mag.c
new file mode 100644
index 0000000000..f477498d6e
--- /dev/null
+++ b/sysdeps/loongarch/fpu/s_fminimum_mag.c
@@ -0,0 +1,40 @@
+/* fminimum_mag().  LoongArch version.
+   Copyright (C) 2022 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#define NO_MATH_REDIRECT
+#include <math.h>
+#include <libm-alias-double.h>
+#include <fpu_control.h>
+
+double
+__fminimum_mag (double x, double y)
+{
+  int x_cond;
+  int y_cond;
+  asm volatile ("fclass.d \t%0, %1" : "=f" (x_cond) : "f" (x));
+  asm volatile ("fclass.d \t%0, %1" : "=f" (y_cond) : "f" (y));
+
+  if (__glibc_unlikely((x_cond | y_cond) & _FCLASS_NAN))
+      return x * y;
+  else
+    {
+      asm volatile ("fmina.d \t%0, %1, %2" : "=f" (x) : "f" (x), "f" (y));
+      return x;
+    }
+}
+libm_alias_double (__fminimum_mag, fminimum_mag)
diff --git a/sysdeps/loongarch/fpu/s_fminimum_magf.c b/sysdeps/loongarch/fpu/s_fminimum_magf.c
new file mode 100644
index 0000000000..d0563fc255
--- /dev/null
+++ b/sysdeps/loongarch/fpu/s_fminimum_magf.c
@@ -0,0 +1,40 @@
+/* fminimum_magf().  LoongArch version.
+   Copyright (C) 2022 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#define NO_MATH_REDIRECT
+#include <math.h>
+#include <libm-alias-float.h>
+#include <fpu_control.h>
+
+float
+__fminimum_magf (float x, float y)
+{
+  int x_cond;
+  int y_cond;
+  asm volatile ("fclass.s \t%0, %1" : "=f" (x_cond) : "f" (x));
+  asm volatile ("fclass.s \t%0, %1" : "=f" (y_cond) : "f" (y));
+
+  if (__glibc_unlikely((x_cond | y_cond) & _FCLASS_NAN))
+      return x * y;
+  else
+    {
+      asm volatile ("fmina.s \t%0, %1, %2" : "=f" (x) : "f" (x), "f" (y));
+      return x;
+    }
+}
+libm_alias_float (__fminimum_mag, fminimum_mag)