diff --git a/sysdeps/loongarch/Makefile b/sysdeps/loongarch/Makefile
index 746d4c2c8f..ccda57e2d4 100644
--- a/sysdeps/loongarch/Makefile
+++ b/sysdeps/loongarch/Makefile
@@ -5,3 +5,21 @@ endif
 # LoongArch's assembler also needs to know about PIC as it changes the
 # definition of some assembler macros.
 ASFLAGS-.os += $(pic-ccflag)
+
+CFLAGS-elf-init.oS += -mcmodel=medium
+CFLAGS-atexit.oS += -mcmodel=medium
+CFLAGS-at_quick_exit.oS += -mcmodel=medium
+CFLAGS-stat.oS += -mcmodel=medium
+CFLAGS-fstat.oS += -mcmodel=medium
+CFLAGS-lstat.oS += -mcmodel=medium
+CFLAGS-stat64.oS += -mcmodel=medium
+CFLAGS-fstat64.oS += -mcmodel=medium
+CFLAGS-lstat64.oS += -mcmodel=medium
+CFLAGS-fstatat.oS += -mcmodel=medium
+CFLAGS-fstatat64.oS += -mcmodel=medium
+CFLAGS-mknod.oS += -mcmodel=medium
+CFLAGS-mknodat.oS += -mcmodel=medium
+CFLAGS-pthread_atfork.oS += -mcmodel=medium
+CFLAGS-warning-nop.oS += -mcmodel=medium
+CFLAGS-stack_chk_fail_local.oS += -mcmodel=medium
+ 
diff --git a/sysdeps/loongarch/at_quick_exit.c b/sysdeps/loongarch/at_quick_exit.c
new file mode 100644
index 0000000000..8d4b44a7eb
--- /dev/null
+++ b/sysdeps/loongarch/at_quick_exit.c
@@ -0,0 +1 @@
+#include <stdlib/at_quick_exit.c>
diff --git a/sysdeps/loongarch/atexit.c b/sysdeps/loongarch/atexit.c
new file mode 100644
index 0000000000..fc055a4851
--- /dev/null
+++ b/sysdeps/loongarch/atexit.c
@@ -0,0 +1 @@
+#include <stdlib/atexit.c>
diff --git a/sysdeps/loongarch/elf-init.c b/sysdeps/loongarch/elf-init.c
new file mode 100644
index 0000000000..5f261a9d16
--- /dev/null
+++ b/sysdeps/loongarch/elf-init.c
@@ -0,0 +1 @@
+#include <sysdeps/init_array/elf-init.c>
diff --git a/sysdeps/loongarch/fstat.c b/sysdeps/loongarch/fstat.c
new file mode 100644
index 0000000000..c4504eebe7
--- /dev/null
+++ b/sysdeps/loongarch/fstat.c
@@ -0,0 +1 @@
+#include <io/fstat.c>
diff --git a/sysdeps/loongarch/fstat64.c b/sysdeps/loongarch/fstat64.c
new file mode 100644
index 0000000000..143ca2b051
--- /dev/null
+++ b/sysdeps/loongarch/fstat64.c
@@ -0,0 +1 @@
+#include <io/fstat64.c>
diff --git a/sysdeps/loongarch/fstatat.c b/sysdeps/loongarch/fstatat.c
new file mode 100644
index 0000000000..0b0a334241
--- /dev/null
+++ b/sysdeps/loongarch/fstatat.c
@@ -0,0 +1 @@
+#include <io/fstatat.c>
diff --git a/sysdeps/loongarch/fstatat64.c b/sysdeps/loongarch/fstatat64.c
new file mode 100644
index 0000000000..e82b927477
--- /dev/null
+++ b/sysdeps/loongarch/fstatat64.c
@@ -0,0 +1 @@
+#include <io/fstatat64.c>
diff --git a/sysdeps/loongarch/lstat.c b/sysdeps/loongarch/lstat.c
new file mode 100644
index 0000000000..f47a56aff8
--- /dev/null
+++ b/sysdeps/loongarch/lstat.c
@@ -0,0 +1 @@
+#include <io/lstat.c>
diff --git a/sysdeps/loongarch/lstat64.c b/sysdeps/loongarch/lstat64.c
new file mode 100644
index 0000000000..d681165600
--- /dev/null
+++ b/sysdeps/loongarch/lstat64.c
@@ -0,0 +1 @@
+#include <io/lstat64.c>
diff --git a/sysdeps/loongarch/mknod.c b/sysdeps/loongarch/mknod.c
new file mode 100644
index 0000000000..1ed3681ffe
--- /dev/null
+++ b/sysdeps/loongarch/mknod.c
@@ -0,0 +1 @@
+#include <io/mknod.c>
diff --git a/sysdeps/loongarch/mknodat.c b/sysdeps/loongarch/mknodat.c
new file mode 100644
index 0000000000..82bc6ee637
--- /dev/null
+++ b/sysdeps/loongarch/mknodat.c
@@ -0,0 +1 @@
+#include <io/mknodat.c>
diff --git a/sysdeps/loongarch/pthread_atfork.c b/sysdeps/loongarch/pthread_atfork.c
new file mode 100644
index 0000000000..0f01d80512
--- /dev/null
+++ b/sysdeps/loongarch/pthread_atfork.c
@@ -0,0 +1 @@
+#include <nptl/pthread_atfork.c>
diff --git a/sysdeps/loongarch/stack_chk_fail_local.c b/sysdeps/loongarch/stack_chk_fail_local.c
new file mode 100644
index 0000000000..305871fbc0
--- /dev/null
+++ b/sysdeps/loongarch/stack_chk_fail_local.c
@@ -0,0 +1 @@
+#include <debug/stack_chk_fail_local.c>
diff --git a/sysdeps/loongarch/stat.c b/sysdeps/loongarch/stat.c
new file mode 100644
index 0000000000..36461b870e
--- /dev/null
+++ b/sysdeps/loongarch/stat.c
@@ -0,0 +1 @@
+#include <io/stat.c>
diff --git a/sysdeps/loongarch/stat64.c b/sysdeps/loongarch/stat64.c
new file mode 100644
index 0000000000..0897282e6a
--- /dev/null
+++ b/sysdeps/loongarch/stat64.c
@@ -0,0 +1 @@
+#include <io/stat64.c>
diff --git a/sysdeps/loongarch/warning-nop.c b/sysdeps/loongarch/warning-nop.c
new file mode 100644
index 0000000000..b76aae79f9
--- /dev/null
+++ b/sysdeps/loongarch/warning-nop.c
@@ -0,0 +1 @@
+#include <debug/warning-nop.c>